// Programmer: Maura Dailey

// Class: CSE 120
// Section: 1
// Date: 02/04/02

// Brief: This program uses a simple set of operations to read words
// from a file, store them into an array, and print them on the screen,
// one per line. The input is ordinary text, but the output varies
// depending on the type of test to be performed. Each test will
// send output to the screen as well as to the output file.

#include <fstream>
#include "string.h"
#include <iostream>

const int MAX_WORDS = 16;

int main()
{
  using namespace std;
  StrType word;
  ifstream inFile;
  StrType words[MAX_WORDS];
  int numWords = 0;
  inFile.open("strtype.txt");
  ofstream outFile;
  outFile.open("outData");

// The following code will execute a test of the GetStringFile function
// of type ALPHA_NUM with the option to skip nonalphanumeric characters.
// It should read from an input stream inFile and create an
// output file outData. Data will also be displayed to the screen.

  word.MakeEmpty();

  // Call the function with the parameters we will test and start a loop
  // to get all words from the input file.

  word.GetStringFile(true, ALPHA_NUM, inFile);

  while(inFile && numWords < MAX_WORDS)
  {
    word.CopyString(words[numWords]);
    numWords++;
    word.GetStringFile(true, ALPHA_NUM, inFile);
  }

  // Start output of results to the screen
  cout << "GetStringFile function, Type = ALPHA_NUM, Skip = Yes : ";

  for(int index = 0; index < numWords; index++)
    words[index].PrintToScreen(true);

  // End output of results to the screen
  cout << endl << endl;

  // Write explanation of the test to the output file for documentation
  outFile << "The following output is produced by the test for the"
          << endl << "GetStringFile function of type ALPHA_NUM assuming that non"
          << endl << "alphanumeric characters will be skipped:" << endl;

  // Write results of the test to the output file
  for(int index = 0; index < numWords; index++)
    words[index].PrintToFile(true, outFile);

  // Close the input stream so we can safely reopen it for the next test
  inFile.close();

// The following code will execute a test of the GetStringFile function
// of type ALPHA_NUM with the option not to skip nonalphanumeric characters.
// It should read from an input stream inFile and create an
// output file outData. Data will also be displayed to the screen.

  // Reset the value of numWords for the next test and reopen the input stream
  numWords = 0;
  inFile.open("strtype.txt");

  word.MakeEmpty();

  // Call the function with the parameters we will test and start a loop
  // to get all words from the input file.

  word.GetStringFile(false, ALPHA_NUM, inFile);

  while(inFile && numWords < MAX_WORDS)
  {
    word.CopyString(words[numWords]);
    numWords++;
    word.GetStringFile(false, ALPHA_NUM, inFile);
  }

  // Start output of results to the screen
  cout << "GetStringFile function, Type = ALPHA_NUM, Skip = No : ";

  for(int index = 0; index < numWords; index++)
    words[index].PrintToScreen(true);

  // End output of results to the screen
  cout << endl << endl;

  // Write explanation of the test to the output file for documentation
  outFile << endl << endl << "The following output is produced by the test for the"
          << endl << "GetStringFile function of type ALPHA_NUM assuming that non"
          << endl << "alphanumeric characters will not be skipped:" << endl;

  // Write results of the test to the output file
  for(int index = 0; index < numWords; index++)
    words[index].PrintToFile(true, outFile);

  // Close input stream so we can safely reopen it for the next test
  inFile.close();

// The following code will execute a test of the GetStringFile function
// of type ALPHA with the option to skip nonalphabetic characters.
// It should read from an input stream inFile and create an
// output file outData. Data will also be displayed to the screen.

  // Reset the value of numWords for the next test and reopen the input stream
  numWords = 0;
  inFile.open("strtype.txt");

  word.MakeEmpty();

  // Call the function with the parameters we will test and start a loop
  // to get all words from the input file.

  word.GetStringFile(true, ALPHA, inFile);

  while(inFile && numWords < MAX_WORDS)
  {
    word.CopyString(words[numWords]);
    numWords++;
    word.GetStringFile(true, ALPHA, inFile);
  }

  // Start output of results to the screen
  cout << "GetStringFile function, Type = ALPHA, Skip = Yes : ";

  for(int index = 0; index < numWords; index++)
    words[index].PrintToScreen(true);

  // End output of results to the screen
  cout << endl << endl;

  // Write explanation of the test to the output file for documentation
  outFile << endl << endl << "The following output is produced by the test for the"
          << endl << "GetStringFile function of type ALPHA assuming that non"
          << endl << "alphabetic characters will be skipped:" << endl;

  // Write results of the test to the output file
  for(int index = 0; index < numWords; index++)
    words[index].PrintToFile(true, outFile);

  // Close the input stream so we can safely reopen it for the next test
  inFile.close();

// The following code will execute a test of the GetStringFile function
// of type ALPHA with the option not to skip nonalphabetic characters.
// It should read from an input stream inFile and create an
// output file outData. Data will also be displayed to the screen.

  // Reset the value of numWords for the next test and reopen the input stream
  numWords = 0;
  inFile.open("strtype.txt");

  word.MakeEmpty();

  // Call the function with the parameters we will test and start a loop
  // to get all words from the input file.

  word.GetStringFile(false, ALPHA, inFile);

  while(inFile && numWords < MAX_WORDS)
  {
    word.CopyString(words[numWords]);
    numWords++;
    word.GetStringFile(false, ALPHA, inFile);
  }

  // Start output of results to the screen
  cout << "GetStringFile function, Type = ALPHA, Skip = No : ";

  for(int index = 0; index < numWords; index++)
    words[index].PrintToScreen(true);

  // End output of results to the screen
  cout << endl << endl;

  // Write explanation of the test to the output file for documentation
  outFile << endl << endl << "The following output is produced by the test for the"
          << endl << "GetStringFile function of type ALPHA assuming that non"
          << endl << "alphabetic characters will not be skipped:" << endl;

  // Write results of the test to the output file
  for(int index = 0; index < numWords; index++)
    words[index].PrintToFile(true, outFile);

  // Close the input stream so we can safely reopen it for the next test
  inFile.close();

// The following code will execute a test of the GetStringFile function
// of type NON_WHITE with the option to skip whitespace characters.
// It should read from an input stream inFile and create an
// output file outData. Data will also be displayed to the screen.

  // Reset the value of numWords for the next test and reopen the input stream
  numWords = 0;
  inFile.open("strtype.txt");

  word.MakeEmpty();

  // Call the function with the parameters we will test and start a loop
  // to get all words from the input file.

  word.GetStringFile(true, NON_WHITE, inFile);

  while(inFile && numWords < MAX_WORDS)
  {
    word.CopyString(words[numWords]);
    numWords++;
    word.GetStringFile(true, NON_WHITE, inFile);
  }

  // Start output of results to the screen
  cout << "GetStringFile function, Type = NON_WHITE, Skip = Yes : ";

  for(int index = 0; index < numWords; index++)
    words[index].PrintToScreen(true);

  // End output of results to the screen
  cout << endl << endl;

  // Write explanation of the test to the output file for documentation
  outFile << endl << endl << "The following output is produced by the test for the"
          << endl << "GetStringFile function of type NON_WHITE assuming that"
          << endl << "whitespace characters will be skipped:" << endl;

  // Write results of the test to the output file
  for(int index = 0; index < numWords; index++)
    words[index].PrintToFile(true, outFile);

  // Close the input stream so we can safely reopen it for the next test
  inFile.close();
  
// The following code will execute a test of the GetStringFile function
// of type NON_WHITE with the option not to skip whitespace characters.
// It should read from an input stream inFile and create an
// output file outData. Data will also be displayed to the screen.

  // Reset the value of numWords for the next test and reopen the input stream
  numWords = 0;
  inFile.open("strtype.txt");

  word.MakeEmpty();

  // Call the function with the parameters we will test and start a loop
  // to get all words from the input file.

  word.GetStringFile(false, NON_WHITE, inFile);

  while(inFile && numWords < MAX_WORDS)
  {
    word.CopyString(words[numWords]);
    numWords++;
    word.GetStringFile(false, NON_WHITE, inFile);
  }

  // Start output of results to the screen
  cout << "GetStringFile function, Type = NON_WHITE, Skip = No : ";

  for(int index = 0; index < numWords; index++)
    words[index].PrintToScreen(true);

  // End output of results to the screen
  cout << endl << endl;

  // Write explanation of the test to the output file for documentation
  outFile << endl << endl << "The following output is produced by the test for the"
          << endl << "GetStringFile function of type NON_WHITE assuming that"
          << endl << "whitespace characters will not be skipped:" << endl;

  // Write results of the test to the output file
  for(int index = 0; index < numWords; index++)
    words[index].PrintToFile(true, outFile);

  // Close the input stream so we can safely reopen it for the next test
  inFile.close();
  
// The following code will execute a test of the GetStringFile function
// of type NOT_NEW with the option to skip newline characters.
// It should read from an input stream inFile and create an
// output file outData. Data will also be displayed to the screen.

  // Reset the value of numWords for the next test and reopen the input stream
  numWords = 0;
  inFile.open("strtype.txt");

  word.MakeEmpty();

  // Call the function with the parameters we will test and start a loop
  // to get all words from the input file.

  word.GetStringFile(true, NOT_NEW, inFile);

  while(inFile && numWords < MAX_WORDS)
  {
    word.CopyString(words[numWords]);
    numWords++;
    word.GetStringFile(true, NOT_NEW, inFile);
  }

  // Start output of results to the screen
  cout << "GetStringFile function, Type = NOT_NEW, Skip = Yes : ";

  for(int index = 0; index < numWords; index++)
    words[index].PrintToScreen(true);

  // End output of results to the screen
  cout << endl << endl;

  // Write explanation of the test to the output file for documentation
  outFile << endl << endl << "The following output is produced by the test for the"
          << endl << "GetStringFile function of type NOT_NEW assuming that"
          << endl << "newline characters will be skipped:" << endl;

  // Write results of the test to the output file
  for(int index = 0; index < numWords; index++)
    words[index].PrintToFile(true, outFile);

  // Close the input stream so we can safely reopen it for the next test
  inFile.close();
  
// The following code will execute a test of the GetStringFile function
// of type NOT_NEW with the option not to skip newline characters.
// It should read from an input stream inFile and create an
// output file outData. Data will also be displayed to the screen.

  // Reset the value of numWords for the next test and reopen the input stream
  numWords = 0;
  inFile.open("strtype.txt");

  word.MakeEmpty();

  // Call the function with the parameters we will test and start a loop
  // to get all words from the input file.

  word.GetStringFile(false, NOT_NEW, inFile);

  while(inFile && numWords < MAX_WORDS)
  {
    word.CopyString(words[numWords]);
    numWords++;
    word.GetStringFile(false, NOT_NEW, inFile);
  }

  // Start output of results to the screen
  cout << "GetStringFile function, Type = NOT_NEW, Skip = No : ";

  for(int index = 0; index < numWords; index++)
    words[index].PrintToScreen(true);

  // End output of results to the screen
  cout << endl << endl;

  // Write explanation of the test to the output file for documentation
  outFile << endl << endl << "The following output is produced by the test for the"
          << endl << "GetStringFile function of type NOT_NEW assuming that"
          << endl << "newline characters will not be skipped:" << endl;

  // Write results of the test to the output file
  for(int index = 0; index < numWords; index++)
    words[index].PrintToFile(true, outFile);

  // Close input and output streams
  inFile.close();
  outFile.close();

  return 0;
}
